import { createApp as fe, h as ge, defineComponent as ee, ref as k, computed as J, resolveComponent as C, openBlock as i, createElementBlock as _, normalizeStyle as ye, unref as o, createVNode as z, withCtx as y, createBlock as v, createCommentVNode as w, onMounted as be, nextTick as G, onUnmounted as me, resolveDirective as ve, createElementVNode as F, renderSlot as j, Fragment as R, renderList as W, createTextVNode as L, toDisplayString as V, isRef as X, withDirectives as we, normalizeClass as Ce, pushScopeId as ke, popScopeId as Se } from "vue";
function _e(e) {
  const n = fe(e), t = document.createElement("div");
  return document.body.appendChild(t), {
    instance: n.mount(t),
    unmount() {
      n.unmount(), document.body.removeChild(t);
    }
  };
}
function xe(e) {
  return (n = {}) => {
    const { unmount: t } = _e({
      setup() {
        const s = {
          dialogVisible: !0,
          close: () => {
            t();
          }
        };
        return () => ge(e, { ...s, ...n });
      }
    });
  };
}
function ze(e, n = !1, t) {
  return e.install = (s) => {
    const { name: g } = e;
    g && (t = g), s.component(t, e), n && (s.config.globalProperties["$" + t] = xe(e));
  }, e;
}
const Ae = () => window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight, Be = /* @__PURE__ */ ee({
  __name: "index",
  props: {
    showSearch: {
      type: Boolean,
      default: !0
    },
    columns: {
      type: Array
    },
    search: {
      type: Boolean,
      default: !0
    },
    gutter: {
      type: Number,
      default: 10
    }
  },
  emits: ["update:showSearch", "queryTable", "transferUpdate"],
  setup(e, { emit: n }) {
    const t = e, s = k([]), g = k("\u663E\u793A/\u9690\u85CF"), T = k(!1), B = J(() => {
      const b = {};
      return t.gutter && (b.marginRight = `${t.gutter / 2}px`), b;
    });
    function I() {
      n("update:showSearch", !t.showSearch);
    }
    function S() {
      n("queryTable");
    }
    function $(b) {
      for (let c in t.columns) {
        const U = t.columns[c].key;
        t.columns[c].visible = !b.includes(U);
      }
      n("transferUpdate", b);
    }
    function q() {
      T.value = !0;
    }
    for (let b in t.columns)
      t.columns[b].visible === !1 && s.value.push(parseInt(b));
    return (b, c) => {
      const U = C("el-button"), E = C("el-tooltip"), H = C("el-row"), O = C("el-transfer"), P = C("el-dialog");
      return i(), _("div", {
        class: "top-right-btn",
        style: ye(o(B))
      }, [
        z(H, null, {
          default: y(() => [
            e.search ? (i(), v(E, {
              key: 0,
              class: "item",
              effect: "dark",
              content: e.showSearch ? "\u9690\u85CF\u641C\u7D22" : "\u663E\u793A\u641C\u7D22",
              placement: "top"
            }, {
              default: y(() => [
                z(U, {
                  circle: "",
                  icon: "Search",
                  onClick: c[0] || (c[0] = (x) => I())
                })
              ]),
              _: 1
            }, 8, ["content"])) : w("", !0),
            z(E, {
              class: "item",
              effect: "dark",
              content: "\u5237\u65B0",
              placement: "top"
            }, {
              default: y(() => [
                z(U, {
                  circle: "",
                  icon: "Refresh",
                  onClick: c[1] || (c[1] = (x) => S())
                })
              ]),
              _: 1
            }),
            e.columns ? (i(), v(E, {
              key: 1,
              class: "item",
              effect: "dark",
              content: "\u663E\u9690\u5217",
              placement: "top"
            }, {
              default: y(() => [
                z(U, {
                  circle: "",
                  icon: "Menu",
                  onClick: c[2] || (c[2] = (x) => q())
                })
              ]),
              _: 1
            })) : w("", !0)
          ]),
          _: 1
        }),
        z(P, {
          title: g.value,
          modelValue: T.value,
          "onUpdate:modelValue": c[4] || (c[4] = (x) => T.value = x),
          "append-to-body": ""
        }, {
          default: y(() => [
            z(O, {
              titles: ["\u663E\u793A", "\u9690\u85CF"],
              modelValue: s.value,
              "onUpdate:modelValue": c[3] || (c[3] = (x) => s.value = x),
              data: e.columns,
              onChange: $
            }, null, 8, ["modelValue", "data"])
          ]),
          _: 1
        }, 8, ["title", "modelValue"])
      ], 4);
    };
  }
});
const te = (e, n) => {
  const t = e.__vccOpts || e;
  for (const [s, g] of n)
    t[s] = g;
  return t;
}, Ue = /* @__PURE__ */ te(Be, [["__scopeId", "data-v-57db9efd"]]), Y = {
  props: {
    permi: {
      type: Array,
      default: () => []
    }
  },
  render(e) {
    return e.$slots.default();
  }
};
let M;
const He = new Uint8Array(16);
function Re() {
  if (!M && (M = typeof crypto < "u" && crypto.getRandomValues && crypto.getRandomValues.bind(crypto), !M))
    throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");
  return M(He);
}
const f = [];
for (let e = 0; e < 256; ++e)
  f.push((e + 256).toString(16).slice(1));
function Ve(e, n = 0) {
  return (f[e[n + 0]] + f[e[n + 1]] + f[e[n + 2]] + f[e[n + 3]] + "-" + f[e[n + 4]] + f[e[n + 5]] + "-" + f[e[n + 6]] + f[e[n + 7]] + "-" + f[e[n + 8]] + f[e[n + 9]] + "-" + f[e[n + 10]] + f[e[n + 11]] + f[e[n + 12]] + f[e[n + 13]] + f[e[n + 14]] + f[e[n + 15]]).toLowerCase();
}
const Te = typeof crypto < "u" && crypto.randomUUID && crypto.randomUUID.bind(crypto), Z = {
  randomUUID: Te
};
function $e(e, n, t) {
  if (Z.randomUUID && !n && !e)
    return Z.randomUUID();
  e = e || {};
  const s = e.random || (e.rng || Re)();
  if (s[6] = s[6] & 15 | 64, s[8] = s[8] & 63 | 128, n) {
    t = t || 0;
    for (let g = 0; g < 16; ++g)
      n[t + g] = s[g];
    return n;
  }
  return Ve(s);
}
const Ee = (e) => (ke("data-v-f1095740"), e = e(), Se(), e), Pe = { class: "header" }, De = /* @__PURE__ */ Ee(() => /* @__PURE__ */ F("div", { class: "dashed mb-2" }, null, -1)), Fe = { class: "flex justify-between pb-2" }, Ie = ["onClick"], qe = { key: 0 }, Ne = ["onClick"], je = /* @__PURE__ */ ee({
  __name: "Table",
  props: {
    isHeader: {
      type: Boolean,
      default: !0
    },
    headerButs: {
      type: Array
    },
    tableButs: {
      type: Array
    },
    tableButsAlign: {
      type: String,
      default: "center"
    },
    columns: {
      type: Array,
      required: !0
    },
    initApi: {
      type: Boolean,
      default: !0
    },
    reqApiMethod: {
      type: Function,
      required: !0
    },
    searchParams: {
      type: Object,
      default: {}
    },
    requestHandler: {
      type: Function,
      default(e = {}) {
        return e;
      }
    },
    responseHandler: {
      type: Function,
      default(e) {
        return e;
      }
    },
    butClickEvent: {
      type: Function,
      default() {
      }
    },
    fixedheader: {
      type: Boolean,
      default: !0
    },
    toolbar: {
      type: Boolean,
      default: !0
    },
    hasPage: {
      type: Boolean,
      default: !0
    },
    pageSize: {
      type: Number,
      default: 10
    },
    pageSizes: {
      type: Array,
      default: () => [10, 20, 30, 40, 50]
    },
    pagingJustify: {
      type: String,
      default: "end"
    },
    height: {
      type: [String, Number]
    },
    stripe: {
      type: Boolean,
      default: !1
    },
    border: {
      type: Boolean,
      default: !1
    },
    showHeader: {
      type: Boolean,
      default: !0
    },
    size: {
      type: String,
      default: "default"
    },
    highlightCurrentRow: {
      type: Boolean,
      default: !1
    },
    rowKey: {
      type: String,
      default: "id"
    },
    treeProps: {
      type: Object,
      default: () => ({ hasChildren: "hasChildren", children: "children" })
    },
    handlerTableRow: {
      type: Function
    },
    handlerHeaderRow: {
      type: Function
    },
    expandAll: {
      type: Boolean,
      default: !1
    },
    mergeTable: {
      type: Function
    }
  },
  setup(e, { expose: n }) {
    const t = e;
    let s = $e(), g = k(!1), T = k(t.height), B = k(!0), I = k(), S = k(1), $ = k(t.pageSize), q = k(0), b = k([]), c = J(() => b.value.filter((l) => l.selection)), U = J(() => t.columns.filter((l) => l.field && l.title).map((l) => ({
      key: l.field,
      label: l.title,
      visible: !0
    }))), E = (l) => {
      l.length === 0 ? t.columns.forEach((r) => {
        r.visible = !0;
      }) : t.columns.forEach((r) => {
        r.visible = !l.includes(r.field);
      }), Q();
    }, H = async ({ isResetPageNumber: l = !1 } = {}) => new Promise((r) => {
      g.value = !0, l && (S.value = 1);
      let h = {};
      Object.keys(t.searchParams).forEach((m) => {
        t.searchParams[m] !== "" && t.searchParams[m] !== "null" && t.searchParams[m] !== "undefined" && t.searchParams[m] !== null && t.searchParams[m] !== void 0 && (h[m] = t.searchParams[m]);
      });
      let p = t.requestHandler({
        pageNum: S.value,
        pageSize: $.value,
        ...h
      });
      Array.isArray(p.dateRange) && p.dateRange.length > 0 && (p.startDate = p.dateRange[0], p.endDate = p.dateRange[1], delete p.dateRange), t.hasPage || (delete p.pageNum, delete p.pageSize), t.reqApiMethod(p).then((m) => {
        g.value = !1, q.value = m.total;
        let D = t.responseHandler(m.rows);
        b.value = D.map((N) => ({
          ...N,
          selection: !1
        })), r();
      }).catch(() => {
        g.value = !1, r();
      });
    }), O = ({ type: l, width: r }) => {
      if (r)
        return r;
      switch (l) {
        case "radio":
        case "selection":
          return "30px";
        case "index":
          return "80px";
        default:
          return "";
      }
    }, P = () => {
      var p, m;
      if (!t.fixedheader)
        return;
      let l = Ae(), r = ((p = document.querySelector(".header")) == null ? void 0 : p.clientHeight) || 0, h = 0;
      try {
        h = ((m = document.querySelector(".pagination")) == null ? void 0 : m.clientHeight) || 0;
      } catch (D) {
        console.warn(D);
      }
      T.value = l - r - h;
    }, x = k(0);
    be(() => {
      G(() => {
        let l = document.querySelectorAll(`.table-but-${s}`);
        x.value = Array.from(l).reduce((r, h) => r + h.clientWidth, l.length * 30);
      }), t.fixedheader && (P(), window.addEventListener("resize", P));
    }), me(() => {
      window.removeEventListener("resize", P);
    }), t.initApi && Promise.resolve().then(() => H());
    let K = (l) => l, le = (l) => {
      $.value = l, H();
    }, ne = (l) => {
      S.value = l, H();
    }, ae = ({ column: l, prop: r, order: h }) => {
      console.log(l, r, h);
    }, oe = (l) => {
      b.value.forEach((r) => r.selection = l.length !== 0);
    }, re = (l) => {
      b.value.forEach((r, h) => {
        r.selection = h === l;
      });
    }, ue = (l, r) => {
      t.handlerHeaderRow && t.handlerHeaderRow(l, r);
    }, ie = (l, r) => {
      t.handlerTableRow && t.handlerTableRow(l, r);
    }, de = ({ row: l, column: r, rowIndex: h, columnIndex: p }) => {
      if (t.mergeTable)
        return t.mergeTable({ row: l, column: r, rowIndex: h, columnIndex: p });
    }, Q = () => {
      G(() => {
        I.value.doLayout();
      });
    };
    return n({
      refreshLayout: Q,
      fetchData: H
    }), (l, r) => {
      const h = C("el-button"), p = C("el-checkbox"), m = C("el-radio"), D = C("el-image"), N = C("el-table-column"), se = C("el-table"), ce = C("el-pagination"), he = C("el-row"), pe = ve("loading");
      return i(), _("div", null, [
        F("div", Pe, [
          o(B) ? j(l.$slots, "search", { key: 0 }, void 0, !0) : w("", !0),
          De,
          F("div", Fe, [
            F("div", null, [
              (i(!0), _(R, null, W(e.headerButs, (d, a) => (i(), _(R, null, [
                d.visible !== !1 ? (i(), v(Y, {
                  permi: d.permi,
                  key: a
                }, {
                  default: y(() => [
                    d.enable == 1 ? (i(), v(h, {
                      key: 0,
                      onClick: (u) => e.butClickEvent(d, o(c)),
                      type: d.color,
                      plain: "",
                      size: "default",
                      disabled: o(c).length !== 1,
                      icon: d.icon
                    }, {
                      default: y(() => [
                        L(V(d.name), 1)
                      ]),
                      _: 2
                    }, 1032, ["onClick", "type", "disabled", "icon"])) : d.enable == 2 ? (i(), v(h, {
                      key: 1,
                      onClick: (u) => e.butClickEvent(d, o(c)),
                      type: d.color,
                      plain: "",
                      size: "default",
                      disabled: o(c).length === 0,
                      icon: d.icon
                    }, {
                      default: y(() => [
                        L(V(d.name), 1)
                      ]),
                      _: 2
                    }, 1032, ["onClick", "type", "disabled", "icon"])) : (i(), v(h, {
                      key: 2,
                      onClick: (u) => e.butClickEvent(d, o(c)),
                      type: d.color,
                      plain: "",
                      size: "default",
                      icon: d.icon
                    }, {
                      default: y(() => [
                        L(V(d.name), 1)
                      ]),
                      _: 2
                    }, 1032, ["onClick", "type", "icon"]))
                  ]),
                  _: 2
                }, 1032, ["permi"])) : w("", !0)
              ], 64))), 256))
            ]),
            e.toolbar ? (i(), v(Ue, {
              key: 0,
              showSearch: o(B),
              "onUpdate:showSearch": r[0] || (r[0] = (d) => X(B) ? B.value = d : B = d),
              onQueryTable: o(H),
              onTransferUpdate: o(E),
              columns: o(U)
            }, null, 8, ["showSearch", "onQueryTable", "onTransferUpdate", "columns"])) : w("", !0)
          ]),
          j(l.$slots, "total", {}, void 0, !0)
        ]),
        we((i(), v(se, {
          ref_key: "table",
          ref: I,
          data: o(b),
          height: o(T),
          stripe: e.stripe,
          border: e.border,
          size: e.size,
          "show-header": e.showHeader,
          "highlight-current-row": e.highlightCurrentRow,
          "default-expand-all": e.expandAll,
          "span-method": o(de),
          onSortChange: o(ae),
          onSelectAll: o(oe),
          "row-key": e.rowKey,
          "tree-props": e.treeProps
        }, {
          default: y(() => {
            var d;
            return [
              (i(!0), _(R, null, W(e.columns, (a) => (i(), _(R, null, [
                a.visible !== !1 ? (i(), v(N, {
                  type: a.type,
                  key: a.field,
                  prop: a.field,
                  label: a.field,
                  width: o(O)(a),
                  fixed: a.fixed,
                  "show-overflow-tooltip": a.overflowTooltip,
                  align: a.align || "left",
                  "class-name": a.className,
                  "label-class-name": a.labelClassName,
                  sortable: a.sortable
                }, {
                  header: y(() => [
                    j(l.$slots, `${a.field}Header`, { row: a }, () => [
                      F("span", {
                        onClick: (u) => o(ue)(a.field, a)
                      }, V(a.title), 9, Ie)
                    ], !0)
                  ]),
                  default: y((u) => [
                    a.type == "index" ? (i(), _("span", qe, V(o(S) == 1 ? u.$index + 1 : (o(S) - 1) * o($) + u.$index + 1), 1)) : w("", !0),
                    a.type == "selection" ? (i(), v(p, {
                      key: 1,
                      modelValue: u.row.selection,
                      "onUpdate:modelValue": (A) => u.row.selection = A
                    }, null, 8, ["modelValue", "onUpdate:modelValue"])) : w("", !0),
                    a.type == "radio" ? (i(), v(m, {
                      key: 2,
                      onClick: (A) => o(re)(u.$index),
                      label: !0,
                      modelValue: u.row.selection,
                      "onUpdate:modelValue": (A) => u.row.selection = A
                    }, null, 8, ["onClick", "modelValue", "onUpdate:modelValue"])) : w("", !0),
                    j(l.$slots, a.field, {
                      row: u.row
                    }, () => [
                      a.preview ? (i(), _(R, { key: 0 }, [
                        u.row[a.field] ? (i(), v(D, {
                          key: 0,
                          style: { width: "30px", height: "30px" },
                          src: o(K)(u.row[a.field]),
                          "preview-src-list": [o(K)(u.row[a.field])],
                          "preview-teleported": ""
                        }, null, 8, ["src", "preview-src-list"])) : w("", !0)
                      ], 64)) : (i(), _("span", {
                        key: 1,
                        onClick: (A) => o(ie)(a.field, u.row)
                      }, V(a.formatter ? a.formatter(u.row[a.field], u.row) : u.row[a.field]), 9, Ne))
                    ], !0)
                  ]),
                  _: 2
                }, 1032, ["type", "prop", "label", "width", "fixed", "show-overflow-tooltip", "align", "class-name", "label-class-name", "sortable"])) : w("", !0)
              ], 64))), 256)),
              e.tableButs && ((d = e.tableButs) == null ? void 0 : d.length) > 0 ? (i(), v(N, {
                key: 0,
                label: "\u64CD\u4F5C",
                width: o(x),
                align: e.tableButsAlign,
                fixed: "right"
              }, {
                default: y((a) => [
                  (i(!0), _(R, null, W(e.tableButs, (u, A) => (i(), _(R, { key: A }, [
                    u.visible !== !1 ? (i(), v(Y, {
                      permi: u.permi,
                      key: A
                    }, {
                      default: y(() => [
                        z(h, {
                          class: Ce(`table-but-${o(s)}`),
                          onClick: (Me) => e.butClickEvent(u, [a.row]),
                          link: "",
                          type: u.color,
                          size: "default",
                          icon: u.icon
                        }, {
                          default: y(() => [
                            L(V(u.formatter ? u.formatter(a.row, u.name) : u.name), 1)
                          ]),
                          _: 2
                        }, 1032, ["class", "onClick", "type", "icon"])
                      ]),
                      _: 2
                    }, 1032, ["permi"])) : w("", !0)
                  ], 64))), 128))
                ]),
                _: 1
              }, 8, ["width", "align"])) : w("", !0)
            ];
          }),
          _: 3
        }, 8, ["data", "height", "stripe", "border", "size", "show-header", "highlight-current-row", "default-expand-all", "span-method", "onSortChange", "onSelectAll", "row-key", "tree-props"])), [
          [pe, o(g)]
        ]),
        e.hasPage ? (i(), v(he, {
          key: 0,
          class: "pagination py-1",
          type: "flex",
          justify: e.pagingJustify
        }, {
          default: y(() => [
            z(ce, {
              background: "",
              "page-size": o($),
              total: o(q),
              "current-page": o(S),
              "onUpdate:current-page": r[1] || (r[1] = (d) => X(S) ? S.value = d : S = d),
              layout: "total,prev,pager,next, sizes, jumper, slot",
              "page-sizes": e.pageSizes,
              onSizeChange: o(le),
              onCurrentChange: o(ne)
            }, null, 8, ["page-size", "total", "current-page", "page-sizes", "onSizeChange", "onCurrentChange"])
          ]),
          _: 1
        }, 8, ["justify"])) : w("", !0)
      ]);
    };
  }
});
const Le = /* @__PURE__ */ te(je, [["__scopeId", "data-v-f1095740"]]), We = ze(Le, !1, "AdTable");
export {
  We as Table,
  We as default
};
